具有Roboguice依赖性的Gradle和多个项目

我正在尝试迁移旧的IntelliJ项目以使用gradle。 但是,在dx步骤期间,assembleDebug失败:

java.lang.IllegalArgumentException: already added: Lcom/google/inject/AbstractModule; at com.android.dx.dex.file.ClassDefsSection.add(ClassDefsSection.java:123) at com.android.dx.dex.file.DexFile.add(DexFile.java:163) at com.android.dx.command.dexer.Main.processClass(Main.java:490) at com.android.dx.command.dexer.Main.processFileBytes(Main.java:459) at com.android.dx.command.dexer.Main.access$400(Main.java:67) at com.android.dx.command.dexer.Main$1.processFileBytes(Main.java:398) at com.android.dx.cf.direct.ClassPathOpener.processArchive(ClassPathOpener.java:245) at com.android.dx.cf.direct.ClassPathOpener.processOne(ClassPathOpener.java:131) at com.android.dx.cf.direct.ClassPathOpener.process(ClassPathOpener.java:109) at com.android.dx.command.dexer.Main.processOne(Main.java:422) at com.android.dx.command.dexer.Main.processAllFiles(Main.java:333) at com.android.dx.command.dexer.Main.run(Main.java:209) at com.android.dx.command.dexer.Main.main(Main.java:174) at com.android.dx.command.Main.main(Main.java:91) 

我的项目分为两个子项目:主项目和图书馆项目。 这两个项目都将Roboguice和Guice作为依赖项。

我尝试了Xav建议的解决方法,将支持库包含在本答案中提到的多个项目中。 鉴于roboguice / guice都是从maven中心拾取的,因此甚至可能不需要解决方法。 我创建了一个虚拟库项目,这是唯一依赖roboguice / guice的项目。 我做到了这一点,以便我的主项目和(真正的)图书馆项目都依赖于这个虚拟项目。 但是,我得到了同样的错误。

怎么解决这个问题?

根目录中的settings.gradle

 include 'MainApp' include 'library' include 'common-library' 

根目录中的build.gradle

 buildscript { repositories { mavenCentral() } dependencies { classpath 'com.android.tools.build:gradle:0.4.2' } } allprojects { version = '1.0' repositories { mavenCentral() } } apply plugin: 'android-reporting' 

main项目中的build.gradle和真正的库项目:

 apply plugin: 'android' android { compileSdkVersion 15 buildToolsVersion "17.0" sourceSets { main { manifest.srcFile 'AndroidManifest.xml' java.srcDirs = ['src'] res.srcDirs = ['res'] } } } dependencies { compile project(':library') // only in main, not in real library compile project(':common-library') } 

虚拟库项目中的build.gradle

 apply plugin: 'android-library' android { compileSdkVersion 15 buildToolsVersion "17.0" sourceSets { main { manifest.srcFile 'AndroidManifest.xml' java.srcDirs = ['src'] res.srcDirs = ['res'] } } } dependencies { compile 'org.roboguice:roboguice:2.0' compile 'com.google.inject:guice:3.0' } 

你正确使用虚拟库是不对的,因为你正在使用Maven。 如果你看看.pom for Roboguice ,它会将Guice列为“no_aop”分类器的依赖项。 但是,您还要在没有分类器的情况下明确列出Guice。 我的猜测是,Maven正在推出这两个版本,这导致了dexing合并冲突。

尝试从Gradle构建文件中删除compile 'com.google.inject:guice:3.0' ,看看它是否构建。

好的,我创立的家伙! 要解决此问题,您可以在build.gradle上为library-project使用“ 排除模块 ”。

这是我的例子:compile(’oauth.signpost:signpost-commonshttp4:1.2.1.2’){exclude module:’httpcore’}